ShareClientBuilder Class
Definition
- java.lang.Object
- com.azure.storage.file.share.ShareClientBuilder
This class provides a fluent builder API to help aid the configuration and instantiation of the ShareClient and ShareAsyncClient, calling buildClient() constructs an instance of ShareClient and calling buildAsyncClient() constructs an instance of ShareAsyncClient.
The client needs the endpoint of the Azure Storage File service, name of the share, and authorization credential. endpoint(String endpoint) gives the builder the endpoint and may give the builder the shareName(String shareName) and a sasToken(String sasToken) that authorizes the client.
Instantiating a synchronous Share Client with SAS token
ShareClient shareClient = new ShareClientBuilder()
.endpoint("https://${accountName}.file.core.windows.net?${SASToken}")
.shareName("myshare")
.buildClient();
Instantiating an Asynchronous Share Client with SAS token
ShareAsyncClient shareAsyncClient = new ShareClientBuilder()
.endpoint("https://{accountName}.file.core.windows.net?{SASToken}")
.shareName("myshare")
.buildAsyncClient();
If the endpoint doesn't contain the query parameters to construct a SAS token it may be set using sasToken(String sasToken).
ShareClient shareClient = new ShareClientBuilder()
.endpoint("https://${accountName}.file.core.windows.net")
.sasToken("${SASTokenQueryParams}")
.shareName("myshare")
.buildClient();
ShareAsyncClient shareAsyncClient = new ShareClientBuilder()
.endpoint("https://{accountName}.file.core.windows.net")
.sasToken("${SASTokenQueryParams}")
.shareName("myshare")
.buildAsyncClient();
Another way to authenticate the client is using a StorageSharedKeyCredential. To create a StorageSharedKeyCredential a connection string from the Storage File service must be used. Set the StorageSharedKeyCredential with connectionString(String connectionString). If the builder has both a SAS token and StorageSharedKeyCredential the StorageSharedKeyCredential will be preferred when authorizing requests sent to the service.
Instantiating a synchronous Share Client with connection string.
String connectionString = "DefaultEndpointsProtocol=https;AccountName={name};AccountKey={key};"
+ "EndpointSuffix={core.windows.net}";
ShareClient shareClient = new ShareClientBuilder()
.connectionString(connectionString).shareName("myshare")
.buildClient();
Instantiating an Asynchronous Share Client with connection string.
String connectionString = "DefaultEndpointsProtocol=https;AccountName={name};AccountKey={key};"
+ "EndpointSuffix={core.windows.net}";
ShareAsyncClient shareAsyncClient = new ShareClientBuilder()
.connectionString(connectionString).shareName("myshare")
.buildAsyncClient();
public class ShareClientBuilder implements HttpTrait<ShareClientBuilder>, ConnectionStringTrait<ShareClientBuilder>, AzureNamedKeyCredentialTrait<ShareClientBuilder>, AzureSasCredentialTrait<ShareClientBuilder>, ConfigurationTrait<ShareClientBuilder>, EndpointTrait<ShareClientBuilder>
- Implements
Constructors
| ShareClientBuilder() |
Creates a builder instance that is able to configure and construct ShareClient and ShareAsyncClient. |
Methods
| addPolicy(HttpPipelinePolicy pipelinePolicy) |
Adds a HttpPipelinePolicy to apply on each request sent. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| buildAsyncClient() |
Creates a ShareAsyncClient based on options set in the builder. Every time If pipeline(HttpPipeline httpPipeline) is set, then the |
| buildClient() |
Creates a ShareClient based on options set in the builder. Every time If pipeline(HttpPipeline httpPipeline) is set, then the |
| clientOptions(ClientOptions clientOptions) |
Allows for setting common properties such as application ID, headers, proxy configuration, etc. Note that it is recommended that this method be called with an instance of the HttpClientOptions class (a subclass of the ClientOptions base class). The HttpClientOptions subclass provides more configuration options suitable for HTTP clients, which is applicable for any class that implements this HttpTrait interface. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| configuration(Configuration configuration) |
Sets the configuration object used to retrieve environment configuration values during building of the client. |
| connectionString(String connectionString) |
Sets the connection string to connect to the service. |
| credential(AzureNamedKeyCredential credential) |
Sets the AzureNamedKeyCredential used to authorize requests sent to the service. |
| credential(AzureSasCredential credential) |
Sets the AzureSasCredential used to authorize requests sent to the service. |
| credential(StorageSharedKeyCredential credential) |
Sets the StorageSharedKeyCredential used to authorize requests sent to the service. |
| endpoint(String endpoint) |
Sets the endpoint for the Azure Storage File instance that the client will interact with. The first path segment, if the endpoint contains path segments, will be assumed to be the name of the share that the client will interact with. Query parameters of the endpoint will be parsed in an attempt to generate a SAS token to authenticate requests sent to the service. |
| getDefaultHttpLogOptions() |
Gets the default log options with Storage headers and query parameters. |
| httpClient(HttpClient httpClient) |
Sets the HttpClient to use for sending and receiving requests to and from the service. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| httpLogOptions(HttpLogOptions logOptions) |
Sets the HttpLogOptions to use when sending and receiving requests to and from the service. If a Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. |
| pipeline(HttpPipeline httpPipeline) |
Sets the HttpPipeline to use for the service client. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. The endpoint(String endpoint) is not ignored when |
| retryOptions(RetryOptions retryOptions) |
Sets the RetryOptions for all the requests made through the client. Note: It is important to understand the precedence order of the HttpTrait APIs. In particular, if a HttpPipeline is specified, this takes precedence over all other APIs in the trait, and they will be ignored. If no HttpPipeline is specified, a HTTP pipeline will be constructed internally based on the settings provided to this trait. Additionally, there may be other APIs in types that implement this trait that are also ignored if an HttpPipeline is specified, so please be sure to refer to the documentation of types that implement this trait to understand the full set of implications. Setting this is mutually exclusive with using retryOptions(RequestRetryOptions retryOptions). Consider using retryOptions(RequestRetryOptions retryOptions) to also set storage specific options. |
| retryOptions(RequestRetryOptions retryOptions) |
Sets the request retry options for all the requests made through the client. Setting this is mutually exclusive with using retryOptions(RetryOptions retryOptions). |
| sasToken(String sasToken) |
Sets the SAS token used to authorize requests sent to the service. |
| serviceVersion(ShareServiceVersion version) |
Sets the ShareServiceVersion that is used when making API requests. If a service version is not provided, the service version that will be used will be the latest known service version based on the version of the client library being used. If no service version is specified, updating to a newer version of the client library will have the result of potentially moving to a newer service version. Targeting a specific service version may also mean that the service will return an error for newer APIs. |
| shareName(String shareName) |
Sets the share that the constructed clients will interact with |
| snapshot(String snapshot) |
Sets the snapshot that the constructed clients will interact with. This snapshot must be linked to the share that has been specified in the builder. |